#!/bin/bash

# if you have compiled the "pbm2wav" c program
# you may want to use this - it is MUCH MUCH MUCH faster than python png2wav
#IMG_TO_WAV_EXE="./pbm2wav_c/pbm2wav"
#STRIP_IMG_EXT=".pgm"

# by default we use the python png2wav
IMG_TO_WAV_EXE="python png2wav.py"
STRIP_IMG_EXT=".png"

echo
echo "converting and reassembling wav audio from sliced scanned image strips"

read -e -p "Path to find source images?: " -i "./scannedStrips" IMAGE_PATH

echo
echo "preprocessing images - this will take a while"
mogrify -contrast-stretch 10% "${IMAGE_PATH}/*${STRIP_IMG_EXT}"

echo
echo "starting image-to-sound conversion..."
$IMG_TO_WAV_EXE -m "$IMAGE_PATH/" -w "reassembled.wav"

echo
echo "post processing reassembled audio"

# -S, show progress
# highpass 70, remove any DC offset
# resample 22050, give an 11.025khz bandwidth
# gain -h, auto-headroom attenuation for following eq
# treble 6 4000, +6dB at 4khz
# treble 9 8000, +9dB at 8khz
# gain -n, normalise
sox -S ./reassembled.wav ./reassembled-proc.wav \
highpass 10 \
rate 22050 \
gain -h \
treble 16 4000 treble 20 8000 \
gain -n

echo
echo "done"
